#ifndef COLLISIO_H
#define COLLISIO_H

/*********************************************************************************************/
/******                        DECLARATIONS ET INITIALISATIONS                          ******/
/******                        -------------------------------                          ******/
/******    collisions : fonction qui s'occupe des collisions de la balle                ******/
/******                                                                                 ******/
/******    Les variables externes sont expliques dans le fichier main.c                ******/
/******                                                                                 ******/
/******    i : variable d'incrmentation                                                ******/
/******                                                                                 ******/
/*********************************************************************************************/

#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>
#include <SDL/SDL_mixer.h>
#include "divers.h"
#include "savefile.h"

void collisions();

extern double ballex, balley, ballez;
extern double ballevx, ballevy, ballevz;
extern int mode, pasbruitage, arret, mouv, j, points;
extern Mix_Chunk * son_4;
extern Mix_Chunk * son_fly;
extern Mix_Chunk * son_5;
extern char score01[10];
extern float palettegy, palettedy;
extern double palettegvy, palettedvy;
extern char * meilleurscore01;
extern char * meilleurscore02;
extern char * meilleurscore03;

int i;

/******************************\DECLARATIONS ET INITIALISATIONS*******************************/


#endif
