#ifndef DIVERS_H
#define DIVERS_H

/*********************************************************************************************/
/******                        DECLARATIONS ET INITIALISATIONS                          ******/
/******                        -------------------------------                          ******/
/******    Reshape : fonction de redimensionnement                                      ******/
/******    Idle    : fonction utilise quand rien d'autre n'est prvu                   ******/
/******    vabs : fonction de valeur absolue trs simplifie utile pour les scores      ******/
/******    lancerballe : fonction de lancement de la balle selon le niveau et un rand   ******/
/******                                                                                 ******/
/******    Les variables externes sont expliques dans le fichier main.c                ******/
/******                                                                                 ******/
/******    randnumber, randnumber2, randnumber3, randnumber4 : nombres random           ******/
/******                                                                                 ******/
/*********************************************************************************************/

#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glut.h>
#include "mouse.h"

void Idle();
void Reshape(int w, int h);
void Reshape2(int w, int h);
int vabs(int valeur);
void lancerballe();
void ascii(int num_police, unsigned char caractere, int x, int y, int taille);
int largeur_texte(unsigned char *texte, int taille, int num_police);
int largeur_caractere(unsigned char a, int taille, int num_police);
void afficher_texte(unsigned char *texte, int taille, int x, int y, int num_police, int center, int anim);
void chatbox_new(unsigned char *phrase, unsigned char *pseudo);
void triutilisateurs();
void triparties();
unsigned char * minuscules_pseudo(unsigned char * texte);
void print_screen();

extern int arret;
extern int mouv;
extern float camx, camy, camz;
extern float vertx, verty, vertz;
extern int j;
extern int refresh;
extern int width, height;
extern float rapportx, rapporty, rapportx2, rapporty2;
extern int mode, choix;
extern int points;
extern int choixia;
extern double ballevx, ballevy;
extern char score01[10];
extern int up, up2, down, down2;

int randnumber, randnumber2, randnumber3, randnumber4;

/******************************\DECLARATIONS ET INITIALISATIONS*******************************/


#endif
