#include "keyboard.h"

/*********************************************************************************************/
/******                         FONCTIONS DE GESTION DU CLAVIER                         ******/
/******                         -------------------------------                         ******/
/******    Les trois fonctions suivantes s'occupent de grer les venements du clavier  ******/
/******    que a soit appuyer sur une touche ou au contraire la relcher.              ******/
/******    Une astuce consistant  viter les rptitions des touches de windows est    ******/
/******    de mettre une variable (up ou down)  1 si la touche a t enfonce et la    ******/
/******    remettre  0 ds que la touche est relche...  Puis de grer les            ******/
/******    dplacements en fonction de ces variables...  C'est trs trs pratique       ******/
/******                                                                                 ******/
/******    ToucheSpec gre les touches particulires (fleches, f1, f2 etc...).          ******/
/******    ToucheSpecUp gre le relachement des touches particulires.                  ******/
/******    Touche gre les touches normales (esc, barre d'espace, lettres et chiffres..)******/
/******    ToucheUp gre le relchement d'une touche quel qu'elle soit                  ******/
/******                                                                                 ******/
/******    Barre d'espace relance la balle et esc quitte le jeu                         ******/
/******                                                                                 ******/
/******    Des techniques ont du tre trouves pour faire varier les touches en fonction******/
/******    de l'angle...  Ca aurait t plus simple de faire une fonction  part et de  ******/
/******    modifier le callback...  J'y ai pens trop tard.                             ******/
/******                                                                                 ******/
/*********************************************************************************************/

void ToucheSpec(int key, int x, int y)
{
	if(key==GLUT_KEY_F10) print_screen();
	else if(arret==1)
	{
		switch (key)
		{
			case GLUT_KEY_UP:	if(((mouv==0) || (mouv==1) || (mouv==4)) && mode==4)
								{
									up2=1;
								}
								else if((mouv==0) || (mouv==1) || (mouv==4))
								{
									up=1;
								}
								break;
			case GLUT_KEY_DOWN: if(((mouv==0) || (mouv==1) || (mouv==4)) && mode==4)
								{
									down2=1;
								}
								else if((mouv==0) || (mouv==1) || (mouv==4))
								{
									down=1;
								}
								break;
			case GLUT_KEY_LEFT: if((mouv==2 || mouv==-1) && mode==4)
								{
									up2=1;
								}
								else if(mouv==2 || mouv==-1)
								{
									up=1;
								}
								else if(mouv==3 && mode==4)
								{
									down2=1;
								}
								else if(mouv==3)
								{
									down=1;
								}
								break;
			case GLUT_KEY_RIGHT:if((mouv==2 || mouv==-1) && mode==4)
								{
									down2=1;
								}
								else if(mouv==2 || mouv==-1)
								{
									down=1;
								}
								else if(mouv==3 && mode==4)
								{
									up2=1;
								}
								else if(mouv==3)
								{
									up=1;
								}
								break;
			default:break;
		}
	}
}

void Touche(unsigned char key, int x, int y)
{
	if(arret==1)
	{
		switch (key)
		{
			case 13:etat=glutGetModifiers();
					if(etat==GLUT_ACTIVE_ALT)
					{
	//					Mix_CloseAudio();
	//					SDL_Quit();
						enregistrerfichier();
						if(reso==1 || reso==2)
						{
							glutLeaveGameMode();
							if(reso_1024==1) glutInitWindowSize(800,600);
							else if(reso_1024==0) glutInitWindowSize(640,480);
							win=glutCreateWindow("PonGL 1.20");
							reso=reso_1024+3;
						}
						else if(reso==3 || reso==4)
						{
							glutDestroyWindow(win);
							if(reso_1024==1) glutGameModeString("1024x768:16@85");
							else if(reso_1024==0) glutGameModeString("800x600:16@85");
							glutEnterGameMode();
							reso=reso_1024+1;
						}
						init();
					}
					break;
			case 27:if(options==1)
					{
						options=0;
						enregistrerfichier();
					}
					else if(reseau==1)
					{
						reseau=0;
					}
					else if(credits==1)
					{
						credits=0;
					}
					else if(menuquit==1)
					{
						menuquit=0;
					}
					else if(menudifficulte==1)
					{
						menudifficulte=0;
					}
					else if(mode==1)
					{
						menuquit=1;
					}
					else
					{
						Mix_HaltMusic();
						if(pasmusique==0)Mix_PlayMusic(son_menu, -1);
						mode=1;Reshape(width,height);
					}
					break;
			case 32:if(barredespace==1 || points==6 || points==0) lancerballe();
					break;
			case 'z':if(mode==4 && ((mouv==0) || (mouv==1) || (mouv==4)) )
					{
						up=1;
					}
					break;
			case 's':if(mode==4 && ((mouv==0) || (mouv==1) || (mouv==4)) )
					{
						down=1;
					}
					break;
			case 'q':if(mode==4 && mouv==2)
					{
						up=1;
					}
					else if(mode==4 && mouv==3)
					{
						down=1;
					}
					break;
			case 'd':if(mode==4 && mouv==2)
					{
						down=1;
					}
					else if(mode==4 && mouv==3)
					{
						up=1;
					}
					break;
			default:break;
		}
	}
	else
	{
		switch (key)
		{
			case 13:etat=glutGetModifiers();
					if(etat==GLUT_ACTIVE_ALT)
					{
//						Mix_CloseAudio();
//						SDL_Quit();
						enregistrerfichier();
						if(reso==1 || reso==2)
						{
							glutLeaveGameMode();
							if(reso_1024==1) glutInitWindowSize(800,600);
							else if(reso_1024==0) glutInitWindowSize(640,480);
							win=glutCreateWindow("PonGL 1.20");
							reso=reso_1024+3;
						}
						else if(reso==3 || reso==4)
						{
							glutDestroyWindow(win);
							if(reso_1024==1) glutGameModeString("1024x768:16@85");
							else if(reso_1024==0) glutGameModeString("800x600:16@85");
							glutEnterGameMode();
							reso=reso_1024+1;
						}
						init();
					}
					break;
			case 27:if(options==1)
					{
						options=0;
						enregistrerfichier();
					}
					else if(reseau==1)
					{
						reseau=0;
					}
					else if(credits==1)
					{
						credits=0;
					}
					else if(menuquit==1)
					{
						menuquit=0;
					}
					else if(menudifficulte==1)
					{
						menudifficulte=0;
					}
					else if(mode==1)
					{
						menuquit=1;
					}
					else
					{
						Mix_HaltMusic();
						if(pasmusique==0)Mix_PlayMusic(son_menu, -1);
						mode=1;Reshape(width,height);
					}
			break;
			default:break;
		}
	}
}

void ToucheUp(unsigned char key, int x, int y)
{
	if(arret==1)
	{
		switch (key)
		{
			case 'z':if(mode==4 && ((mouv==0) || (mouv==1) || (mouv==4)) )
					{
						up=0;
					}
					break;
			case 's':if(mode==4 && ((mouv==0) || (mouv==1) || (mouv==4)) )
					{
						down=0;
					}
					break;
			case 'q':if(mode==4 && mouv==2)
					{
						up=0;
					}
					else if(mode==4 && mouv==3)
					{
						down=0;
					}
					break;
			case 'd':if(mode==4 && mouv==2)
					{
						down=0;
					}
					else if(mode==4 && mouv==3)
					{
						up=0;
					}
					break;
			default:break;
		}
	}
}

void ToucheSpecUp(int key, int x, int y)
{
	if(arret==1)
	{
		switch (key)
		{
			case GLUT_KEY_UP:   if(((mouv==0) || (mouv==1) || (mouv==4)) && mode==4)
								{
									up2=0;
								}
								else if((mouv==0) || (mouv==1) || (mouv==4))
								{
									up=0;
								}
								break;
			case GLUT_KEY_DOWN: if(((mouv==0) || (mouv==1) || (mouv==4)) && mode==4)
								{
									down2=0;
								}
								else if((mouv==0) || (mouv==1) || (mouv==4))
								{
									down=0;
								}
								break;
			case GLUT_KEY_LEFT: if((mouv==2 || mouv==-1) && mode==4)
								{
									up2=0;
								}
								else if(mouv==2 || mouv==-1)
								{
									up=0;
								}
								else if(mouv==3 && mode==4)
								{
									down2=0;
								}
								else if(mouv==3)
								{
									down=0;
								}
								break;
			case GLUT_KEY_RIGHT:if((mouv==2 || mouv==-1) && mode==4)
								{
									down2=0;
								}
								else if(mouv==2 || mouv==-1)
								{
									down=0;
								}
								else if(mouv==3 && mode==4)
								{
									up2=0;
								}
								else if(mouv==3)
								{
									up=0;
								}
								break;
			default:break;
		}
	}
}

/*******************************\FONCTIONS DE GESTION DU CLAVIER******************************/

void Touche2(unsigned char key, int x, int y)
{
	int size_pseudo;
	size_pseudo=strlen((char *)pseudo);

	if(key>=32 && key<=159 && size_pseudo<12)
	{
		pseudo=(unsigned char*)realloc(pseudo, (size_pseudo+2)*sizeof(unsigned char));
		pseudo[size_pseudo]=key;
		pseudo[size_pseudo+1]='\0';
	}
	else if((key==233 || key==232) && size_pseudo<12)
	{
		pseudo=(unsigned char*)realloc(pseudo, (size_pseudo+2)*sizeof(unsigned char));
		pseudo[size_pseudo]='e';
		pseudo[size_pseudo+1]='\0';
	}
	else if(key==224 && size_pseudo<12)
	{
		pseudo=(unsigned char*)realloc(pseudo, (size_pseudo+2)*sizeof(unsigned char));
		pseudo[size_pseudo]='a';
		pseudo[size_pseudo+1]='\0';
	}
	else if(key==231 && size_pseudo<12)
	{
		pseudo=(unsigned char*)realloc(pseudo, (size_pseudo+2)*sizeof(unsigned char));
		pseudo[size_pseudo]='c';
		pseudo[size_pseudo+1]='\0';
	}
	else if(key==8)
	{
		if(size_pseudo>=1)
		{
			pseudo=(unsigned char*)realloc(pseudo, (size_pseudo)*sizeof(unsigned char));
			pseudo[size_pseudo-1]='\0';
		}
	}

	if(key==13)
	{
		etat=glutGetModifiers();
		if(etat==GLUT_ACTIVE_ALT)
		{
//			Mix_CloseAudio();
//			SDL_Quit();
			enregistrerfichier();
			if(reso==1 || reso==2)
			{
				glutLeaveGameMode();
				if(reso_1024==1) glutInitWindowSize(800,600);
				else if(reso_1024==0) glutInitWindowSize(640,480);
				win=glutCreateWindow("PonGL 1.20");
				reso=reso_1024+3;
			}
			else if(reso==3 || reso==4)
			{
				glutDestroyWindow(win);
				if(reso_1024==1) glutGameModeString("1024x768:16@85");
				else if(reso_1024==0) glutGameModeString("800x600:16@85");
				glutEnterGameMode();
				reso=reso_1024+1;
			}
			init();
		}
		else
		{
			reseau=0;
			menuip=1;
		}
	}
	else if(key==27)
	{
		reseau=0;
		glutKeyboardFunc(Touche);
	}
}

void Touche3(unsigned char key, int x, int y)
{
	int size_ip;
	size_ip=strlen((char *)ip);

	if(key>=32 && key<=159 && size_ip<15)
	{
		ip=(unsigned char*)realloc(ip, (size_ip+2)*sizeof(unsigned char));
		ip[size_ip]=key;
		ip[size_ip+1]='\0';
	}
	else if((key==233 || key==232) && size_ip<15)
	{
		ip=(unsigned char*)realloc(ip, (size_ip+2)*sizeof(unsigned char));
		ip[size_ip]='e';
		ip[size_ip+1]='\0';
	}
	else if(key==224 && size_ip<15)
	{
		ip=(unsigned char*)realloc(ip, (size_ip+2)*sizeof(unsigned char));
		ip[size_ip]='a';
		ip[size_ip+1]='\0';
	}
	else if(key==231 && size_ip<15)
	{
		ip=(unsigned char*)realloc(ip, (size_ip+2)*sizeof(unsigned char));
		ip[size_ip]='c';
		ip[size_ip+1]='\0';
	}
	else if(key==8)
	{
		if(size_ip>=1)
		{
			ip=(unsigned char*)realloc(ip, (size_ip)*sizeof(unsigned char));
			ip[size_ip-1]='\0';
		}
	}

	if(key==13)
	{
		etat=glutGetModifiers();
		if(etat==GLUT_ACTIVE_ALT)
		{
//			Mix_CloseAudio();
//			SDL_Quit();
			enregistrerfichier();
			if(reso==1 || reso==2)
			{
				glutLeaveGameMode();
				if(reso_1024==1) glutInitWindowSize(800,600);
				else if(reso_1024==0) glutInitWindowSize(640,480);
				win=glutCreateWindow("PonGL 1.20");
				reso=reso_1024+3;
			}
			else if(reso==3 || reso==4)
			{
				glutDestroyWindow(win);
				if(reso_1024==1) glutGameModeString("1024x768:16@85");
				else if(reso_1024==0) glutGameModeString("800x600:16@85");
				glutEnterGameMode();
				reso=reso_1024+1;
			}
			init();
		}
	}
	else if(key==27)
	{
		menuip=0;
		glutKeyboardFunc(Touche);
	}
}


void Touche4(unsigned char key, int x, int y)
{
	int size_chatboxtext;
	int condition;
	size_chatboxtext=strlen((char *)chatboxtext);


	condition=((largeur_texte((unsigned char *)pseudo, 18*rapportx2, 4) + 3*rapportx2 + largeur_texte((unsigned char *)chatboxtext, 18*rapportx2, 3) + largeur_texte((unsigned char *)"[]", 18*rapportx2, 4) < 387*rapportx2) && (largeur_texte((unsigned char *)chatboxtext, 19*rapportx2, 4) < 336*rapportx2));

	if(key>=32 && key<=159 && condition)
	{
		chatboxtext=(unsigned char*)realloc(chatboxtext, (size_chatboxtext+2)*sizeof(unsigned char));
		chatboxtext[size_chatboxtext]=key;
		chatboxtext[size_chatboxtext+1]='\0';
	}
	else if((key==233 || key==232) && condition)
	{
		chatboxtext=(unsigned char*)realloc(chatboxtext, (size_chatboxtext+2)*sizeof(unsigned char));
		chatboxtext[size_chatboxtext]='e';
		chatboxtext[size_chatboxtext+1]='\0';
	}
	else if(key==224 && condition)
	{
		chatboxtext=(unsigned char*)realloc(chatboxtext, (size_chatboxtext+2)*sizeof(unsigned char));
		chatboxtext[size_chatboxtext]='a';
		chatboxtext[size_chatboxtext+1]='\0';
	}
	else if(key==231 && condition)
	{
		chatboxtext=(unsigned char*)realloc(chatboxtext, (size_chatboxtext+2)*sizeof(unsigned char));
		chatboxtext[size_chatboxtext]='c';
		chatboxtext[size_chatboxtext+1]='\0';
	}
	else if(key==8)
	{
		if(size_chatboxtext>=1)
		{
			chatboxtext=(unsigned char*)realloc(chatboxtext, (size_chatboxtext)*sizeof(unsigned char));
			chatboxtext[size_chatboxtext-1]='\0';
		}
	}

	if(key==13)
	{
		etat=glutGetModifiers();
		if(etat==GLUT_ACTIVE_ALT)
		{
//			Mix_CloseAudio();
//			SDL_Quit();
			enregistrerfichier();
			if(reso==1 || reso==2)
			{
				glutLeaveGameMode();
				if(reso_1024==1) glutInitWindowSize(800,600);
				else if(reso_1024==0) glutInitWindowSize(640,480);
				win=glutCreateWindow("PonGL 1.20");
				reso=reso_1024+3;
			}
			else if(reso==3 || reso==4)
			{
				glutDestroyWindow(win);
				if(reso_1024==1) glutGameModeString("1024x768:16@85");
				else if(reso_1024==0) glutGameModeString("800x600:16@85");
				glutEnterGameMode();
				reso=reso_1024+1;
			}
			init();
		}
		else
		{
			if(strlen((char *)chatboxtext) != 0)
			{
				chatbox_new(chatboxtext, pseudo);
				chatboxtext=(unsigned char*)realloc(chatboxtext, sizeof(unsigned char));
				chatboxtext[0]='\0';
			}
		}
	}
	else if(key==27)
	{
		menureseau=0;
		glutKeyboardFunc(Touche);
		glutDisplayFunc(Display);
	}
}

void Touche5(unsigned char key, int x, int y)
{
	int size_newgametext;
	int condition;
	size_newgametext=strlen((char *)newgametext);


	condition=(largeur_texte(newgametext, 19*rapportx2, 4) < 250 && size_newgametext < 30);

	if(key>=32 && key<=159 && condition)
	{
		newgametext=(unsigned char*)realloc(newgametext, (size_newgametext+2)*sizeof(unsigned char));
		newgametext[size_newgametext]=key;
		newgametext[size_newgametext+1]='\0';
	}
	else if((key==233 || key==232) && condition)
	{
		newgametext=(unsigned char*)realloc(newgametext, (size_newgametext+2)*sizeof(unsigned char));
		newgametext[size_newgametext]='e';
		newgametext[size_newgametext+1]='\0';
	}
	else if(key==224 && condition)
	{
		newgametext=(unsigned char*)realloc(newgametext, (size_newgametext+2)*sizeof(unsigned char));
		newgametext[size_newgametext]='a';
		newgametext[size_newgametext+1]='\0';
	}
	else if(key==231 && condition)
	{
		newgametext=(unsigned char*)realloc(newgametext, (size_newgametext+2)*sizeof(unsigned char));
		newgametext[size_newgametext]='c';
		newgametext[size_newgametext+1]='\0';
	}
	else if(key==8)
	{
		if(size_newgametext>=1)
		{
			newgametext=(unsigned char*)realloc(newgametext, (size_newgametext)*sizeof(unsigned char));
			newgametext[size_newgametext-1]='\0';
		}
	}

	if(key==13)
	{
		etat=glutGetModifiers();
		if(etat==GLUT_ACTIVE_ALT)
		{
//			Mix_CloseAudio();
//			SDL_Quit();
			enregistrerfichier();
			if(reso==1 || reso==2)
			{
				glutLeaveGameMode();
				if(reso_1024==1) glutInitWindowSize(800,600);
				else if(reso_1024==0) glutInitWindowSize(640,480);
				win=glutCreateWindow("PonGL 1.20");
				reso=reso_1024+3;
			}
			else if(reso==3 || reso==4)
			{
				glutDestroyWindow(win);
				if(reso_1024==1) glutGameModeString("1024x768:16@85");
				else if(reso_1024==0) glutGameModeString("800x600:16@85");
				glutEnterGameMode();
				reso=reso_1024+1;
			}
			init();
		}
		else
		{
			if(strlen((char *)newgametext) != 0)
			{
				chatbox_new(newgametext, pseudo);
				newgametext=(unsigned char*)realloc(newgametext, sizeof(unsigned char));
				newgametext[0]='\0';
			}
		}
	}
	else if(key==27)
	{
		menureseau=0;
		glutKeyboardFunc(Touche);
		glutDisplayFunc(Display);
	}
}

