#include "mouse.h"

/*********************************************************************************************/
/******                    FONCTION DE GESTION DES CLICS DE LA SOURIS                   ******/
/******                    ------------------------------------------                   ******/
/******    Cette fonction agit lorsqu'un bouton de la souris est cliqu.  Une fois que  ******/
/******    cel se produit, elle regarde la valeur de choix et agit en fonction pour    ******/
/******    que se produise l'venement voulu.                                           ******/
/******                                                                                 ******/
/*********************************************************************************************/

void sourisclic(int bouton, int etat, int x, int y)
{
	if(bouton == 2 && etat == 1)
	{
		Touche(27, 0, 0);
	}
	
	if(bouton==0 && etat==1 && mode==1)
	{
		if(choix==1)
		{
			Mix_HaltMusic();
			if(pasmusique==0)Mix_PlayMusic(son_jeu, -1);
			mode=2;
			mouv=-1;
			camy=0;camx=-550;verty=0;vertx=1;
			arret=0;
			glutWarpPointer(glutGet(GLUT_WINDOW_WIDTH)/2, glutGet(GLUT_WINDOW_HEIGHT)/2);
		}
		else if(choix==2)
		{
			menudifficulte=1;
		}
		else if(choix==3)
		{
			Mix_HaltMusic();
			if(pasmusique==0)Mix_PlayMusic(son_jeu, -1);
			mode=4;
			mouv=0;
			camy=0;camx=0;verty=1;vertx=0;
			arret=0;
			choixia=0;
			glutWarpPointer(glutGet(GLUT_WINDOW_WIDTH)/2, glutGet(GLUT_WINDOW_HEIGHT)/2);
		}
		else if(choix==4)
		{
			reseau=1;
		}
		else if(choix==5)
		{
			options=1;
		}
		else if(choix==6)
		{
			credits=1;
		}
		else if(choix==7)
		{
			if(sourisactive==1)sourisactive=0;
			else if(sourisactive==0)sourisactive=1;
		}
		else if(choix==8)
		{
			if(fer==1)fer=0;
			else if(fer==0)fer=1;
		}
		else if(choix==9)
		{
			if(accballe==1)accballe=0;
			else if(accballe==0)accballe=1;
		}
		else if(choix==10)
		{
			if(inertie==1)inertie=0;
			else if(inertie==0)inertie=1;
		}
		else if(choix==11)
		{
//			Mix_CloseAudio();
//			SDL_Quit();
			enregistrerfichier();
			if(reso_1024==1)
			{
				reso_1024=0;
				if(reso==2)
				{
					reso=1;
					glutLeaveGameMode();
					glutGameModeString("800x600:16@85");
					glutEnterGameMode();
				}
				else if(reso==4)
				{
					reso=3;
					glutDestroyWindow(win);
					glutInitWindowSize(640,480);
					win=glutCreateWindow("PonGL 1.20");
				}
			}
			else if(reso_1024==0)
			{
				reso_1024=1;
				if(reso==1)
				{
					reso=2;
					glutLeaveGameMode();
					glutGameModeString("1024x768:16@85");
					glutEnterGameMode();
				}
				else if(reso==3)
				{
					reso=4;
					glutDestroyWindow(win);
					glutInitWindowSize(800,600);
					win=glutCreateWindow("PonGL 1.20");
				}
			}
			init();
		}
		else if(choix==20)
		{
			if(pasmusique==1)
			{
				pasmusique=0;
				Mix_PlayMusic(son_menu, -1);
			}
			else if(pasmusique==0)
			{
				pasmusique=1;
				Mix_HaltMusic();
			}
		}
		else if(choix==21)
		{
			if(pasbruitage==1)pasbruitage=0;
			else if(pasbruitage==0)pasbruitage=1;
		}
		else if(choix==22)
		{
			if(barredespace==1)barredespace=0;
			else if(barredespace==0)barredespace=1;
		}
		else if(choix==12)
		{
			options=0;
			enregistrerfichier();
		}
		else if(choix==13)
		{
			credits=0;
		}
		else if(choix==23)
		{
			reseau=0;
#ifndef BLOCK_RESEAU
			menuip=1;
#endif
		}
		else if(choix==24)
		{
			Touche(27,0,0);
		}
		else if(choix==25)
		{
			loadTGA("data/ascii2.tga",29);
			loadTGA("data/menureseau.tga",30);
			glutDisplayFunc(Displayreseau);
			menuip=0;
			menureseau=1;
			glutKeyboardFunc(Touche4);
		}
		else if(choix==26)
		{
			if(strlen((char *)chatboxtext) != 0)
			{
				chatbox_new(chatboxtext, pseudo);
				chatboxtext=(unsigned char*)realloc(chatboxtext, sizeof(unsigned char));
				chatboxtext[0]='\0';
			}
		}
		else if(choix==27 || choix==28 || choix==29 || choix==30 || choix==31)
		{
			infos=choix-27;
		}
		else if(choix==32)
		{
			inputline=1;
			glutKeyboardFunc(Touche4);
		}
		else if(choix==33)
		{
			inputline=0;
			glutKeyboardFunc(Touche5);
		}
		else if(choix==34)
		{
			if(accballereseau)accballereseau=0;
			else accballereseau=1;
		}
		else if(choix == 35) // mode franais
		{
			if(langue != 0)
			{
				loadTGA("data/menu.tga",2);
				loadTGA("data/joueur1gagne.tga",13);
				loadTGA("data/joueur2gagne.tga",14);
				loadTGA("data/options.tga",15);
				loadTGA("data/options2.tga",26);
				loadTGA("data/credits.tga",16);
				loadTGA("data/quitter.tga",17);
				loadTGA("data/difficulte.tga",18);
				loadTGA("data/waitreseau.tga",29);
				strcpy(victoire, "Victoires");
				strcpy(score, "Score actuel");
				strcpy(meilleursscores, "Meilleurs scores");
				langue = 0;
				enregistrerfichier();
			}
		}
		else if(choix == 36) // mode anglais
		{
			if(langue != 1)
			{
				loadTGA("data/menu-e.tga",2);
				loadTGA("data/joueur1gagne-e.tga",13);
				loadTGA("data/joueur2gagne-e.tga",14);
				loadTGA("data/options-e.tga",15);
				loadTGA("data/options2-e.tga",26);
				loadTGA("data/credits-e.tga",16);
				loadTGA("data/quitter-e.tga",17);
				loadTGA("data/difficulte-e.tga",18);
				loadTGA("data/waitreseau-e.tga",29);
				strcpy(victoire, "Victories");
				strcpy(score, "Current score");
				strcpy(meilleursscores, "Best scores");
				langue = 1;
				enregistrerfichier();
			}
		}
		else if(choix==14)
		{
//			Mix_CloseAudio();
//			SDL_Quit();
			if(reso==1 || reso==2) glutLeaveGameMode();
			else if(reso==3 || reso==4) glutDestroyWindow(win);
			exit(0);
		}
		else if(choix==15 || choix==16 || choix==17 || choix==18 || choix==19)
		{
			Mix_HaltMusic();
			if(pasmusique==0)Mix_PlayMusic(son_jeu, -1);
			menudifficulte=0;
			mode=3;
			mouv=0;
			camy=0;camx=0;verty=1;vertx=0;
			arret=0;
			if(choix==15) choixia=1;
			else if(choix==16) choixia=2;
			else if(choix==17) choixia=3;
			else if(choix==18) choixia=4;
			else if(choix==19) choixia=5;
			glutWarpPointer(glutGet(GLUT_WINDOW_WIDTH)/2, glutGet(GLUT_WINDOW_HEIGHT)/2);
		}

		/* Active la synchronisation verticale si le refresh n'est pas respect */
		if(fps>90) vsync=1;
		ballex=0;balley=0;ballez=-5;ballevx=0;ballevy=0;ballevz=0;rotballe=0;palettegy=0;palettedy=0;palettegvy=0;palettedvy=0;choix=0;forme=0;son=1;up2=0;down2=0;camz=100000;points=3;ajoutpoint=0;sprintf(score01, "%d", 0);j=0;
		Reshape(width,height);
	}
}

void sourisclic2(int bouton, int etat, int x, int y)
{
	if(bouton==0 && etat==1)
	{
		if(reso==1)
		{
//			Mix_CloseAudio();
//			SDL_Quit();
			reso_1024=0;
			glutDestroyWindow(win);
			glutGameModeString("800x600:16@85");
			glutEnterGameMode();
			init();
		}
		else if(reso==2)
		{
//			Mix_CloseAudio();
//			SDL_Quit();
			reso_1024=1;
			glutDestroyWindow(win);
			glutGameModeString("1024x768:16@85");
			glutEnterGameMode();
			init();
		}
		else if(reso==3)
		{
//			Mix_CloseAudio();
//			SDL_Quit();
			reso_1024=0;
			glutDestroyWindow(win);
			glutInitWindowSize(640,480);
			win=glutCreateWindow("PonGL 1.20");
			init();
		}
		else if(reso==4)
		{
//			Mix_CloseAudio();
//			SDL_Quit();
			reso_1024=1;
			glutDestroyWindow(win);
			glutInitWindowSize(800,600);
			win=glutCreateWindow("PonGL 1.20");
			init();
		}
	}
}

/*************************\FONCTION DE GESTION DES CLICS DE LA SOURIS*************************/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
/*********************************************************************************************/
/******                  FONCTION DE GESTION DU DEPLACEMENT DE LA SOURIS                ******/
/******                  -----------------------------------------------                ******/
/******    Cette fonction sert juste  rcuprer la position de la souris sur les deux  ******/
/******    axes.                                                                        ******/
/******                                                                                 ******/
/*********************************************************************************************/

void souris(int x, int y)
{
	sourismouvx = 0;
	
	if(sourisactive == 1)
	{
		// Dplacement vertical
		if(mouv==0 || mouv==1 || mouv==4)
			sourismouvx = ((float)height/2.-(float)y)/rapportx*0.5*(sensibilitesouris/50);
		// Dplacement horizontal "avantage adversaire"
		else if(mouv==3)
			sourismouvx = (-(float)width/2.+(float)x)/rapportx*0.5*(sensibilitesouris/50);
		// Dplacement horizontal "avantage joueur"
		else
			sourismouvx = ((float)width/2.-(float)x)/rapportx*0.5*(sensibilitesouris/50);
	}
		
	sourisx=x;
	sourisy=height-y;
}

/***********************\FONCTION DE GESTION DU DEPLACEMENT DE LA SOURIS**********************/

