#ifndef MOUVPAL_H
#define MOUVPAL_H

/*********************************************************************************************/
/******                        DECLARATIONS ET INITIALISATIONS                          ******/
/******                        -------------------------------                          ******/
/******    deplacementpaletteg : fonction qui s'occupe du dplacement de la palette de  ******/
/******                          gauche en prenant en compte l'inertie                  ******/
/******    deplacementpaletted : fonction qui s'occupe du dplacement de la palette de  ******/
/******                          droite en prenant en compte l'inertie                  ******/
/******    deplacementpaletteg2 : fonction qui s'occupe du dplacement de la palette de ******/
/******                           gauche sans prendre en compte l'inertie               ******/
/******    deplacementpaletted2 : fonction qui s'occupe du dplacement de la palette de ******/
/******                           droite sans prendre en compte l'inertie               ******/
/******                                                                                 ******/
/******    Les variables externes sont expliques dans le fichier main.c                ******/
/******                                                                                 ******/
/*********************************************************************************************/

#include <GL/gl.h>
#include <stdlib.h>
#include <stdio.h>

void deplacementpaletteg();
void deplacementpaletted();
void deplacementpaletteg2();
void deplacementpaletted2();

extern int up;
extern int down;
extern int up2;
extern int down2;
extern float palettegy;
extern double palettegvy;
extern float palettedy;
extern double palettedvy;
extern int refresh;
extern float sourismouvx, sourismouvy;

/******************************\DECLARATIONS ET INITIALISATIONS*******************************/

#endif
