#ifndef SAVEFILE_H
#define SAVEFILE_H

/*********************************************************************************************/
/******                        DECLARATIONS ET INITIALISATIONS                          ******/
/******                        -------------------------------                          ******/
/******    enregistrerfichier : fonction qui enregistre nos prfrences et les scores   ******/
/******    lirefichier : fonction qui lit nos prfrences et les scores (au dmarrage)  ******/
/******                                                                                 ******/
/******    Les variables externes sont expliques dans le fichier main.c                ******/
/******                                                                                 ******/
/*********************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void enregistrerfichier();
int numofline(char * line); // Retourne le nombre du dbut d'une ligne (en int)
char * textofline(char * line); // Retourne le nombre du dbut d'une ligne (en char*)
void lirefichier();
void lireini();

extern int vsync, sourisactive, sensibilitesouris, fer, accballe, inertie, reso_1024, pasmusique, pasbruitage, barredespace;
extern int langue;
extern char * victoire01;
extern char * victoire02;
extern char * victoire03;
extern char * victoire04;
extern char * victoire05;
extern char * meilleurscore01;
extern char * meilleurscore02;
extern char * meilleurscore03;
extern int inichars[256];
extern int inichars2[256];

/******************************\DECLARATIONS ET INITIALISATIONS*******************************/

#endif
