#include "decor.h"

/*********************************************************************************************/
/******                       FONCTION D'AFFICHAGE DES PALETTES                         ******/
/******                       ---------------------------------                         ******/
/******    Ici non plus rien de bien compliqu, la fonction se contente d'afficher     ******/
/******    l'cran les palettes (fonctions distinctes).                                 ******/
/******    glColor3d choisi la couleur active (blanche et ensuite noire).               ******/
/******    Ce qui se trouve entre glBegin(GL_QUADS) et glEnd va former des faces        ******/
/******    blanches et ce qui se trouve entre glBegin(GL_LINES) et glEnd va former les  ******/
/******    lignes noires                                                                ******/
/******                                                                                 ******/
/*********************************************************************************************/

void affichagepaletteg()
{
	glColor3d(1,1,1);

	glBegin(GL_QUADS);

	glVertex3f(-310,50,15);		//
	glVertex3f(-300,50,15);		// palette de gauche et face tourne vers +z
	glVertex3f(-300,-50,15);	//
	glVertex3f(-310,-50,15);	//

	glVertex3f(-310,50,-15);	//
	glVertex3f(-300,50,-15);	// palette de gauche et face tourne vers -z
	glVertex3f(-300,-50,-15);	//
	glVertex3f(-310,-50,-15);	//

	glVertex3f(-300,50,15);		//
	glVertex3f(-300,50,-15);	// palette de gauche et face tourne vers x
	glVertex3f(-300,-50,-15);	//
	glVertex3f(-300,-50,15);	//

	glVertex3f(-310,50,15);		//
	glVertex3f(-310,50,-15);	// palette de gauche et face tourne vers -x
	glVertex3f(-310,-50,-15);	//
	glVertex3f(-310,-50,15);	//

	glVertex3f(-310,50,15);		//
	glVertex3f(-300,50,15);		// palette de gauche et face tourne vers +y
	glVertex3f(-300,50,-15);	//
	glVertex3f(-310,50,-15);	//

	glVertex3f(-310,-50,15);	//
	glVertex3f(-300,-50,15);	// palette de gauche et face tourne vers -y
	glVertex3f(-300,-50,-15);	//
	glVertex3f(-310,-50,-15);	//

	glEnd();

	glColor3d(0,0,0);
	glBegin(GL_LINES);

	glVertex3f(-299.9,50.1,15.1);glVertex3f(-299.9,-50.1,15.1);		//
	glVertex3f(-310.1,50.1,15.1);glVertex3f(-310.1,-50.1,15.1);		//
	glVertex3f(-299.9,50.1,-15.1);glVertex3f(-299.9,-50.1,-15.1);	// coordonnes
	glVertex3f(-310.1,50.1,-15.1);glVertex3f(-310.1,-50.1,-15.1);	// des
	glVertex3f(-310.1,50.1,15.1);glVertex3f(-299.9,50.1,15.1);		// lignes
	glVertex3f(-310.1,50.1,-15.1);glVertex3f(-299.9,50.1,-15.1);	// noires
	glVertex3f(-310.1,-50.1,15.1);glVertex3f(-299.9,-50.1,15.1);	// composant
	glVertex3f(-310.1,-50.1,-15.1);glVertex3f(-299.9,-50.1,-15.1);	// la
	glVertex3f(-310.1,50.1,15.1);glVertex3f(-310.1,50.1,-15.1);		// palette
	glVertex3f(-299.9,50.1,15.1);glVertex3f(-299.9,50.1,-15.1);		// de gauche
	glVertex3f(-310.1,-50.1,15.1);glVertex3f(-310.1,-50.1,-15.1);	//
	glVertex3f(-299.9,-50.1,15.1);glVertex3f(-299.9,-50.1,-15.1);	//

	glEnd();
}

void affichagepaletted()
{
	glColor3d(1,1,1);

	glBegin(GL_QUADS);

	glVertex3f(310,50,15);		//
	glVertex3f(300,50,15);		// palette de droite et face tourne vers +z
	glVertex3f(300,-50,15);		//
	glVertex3f(310,-50,15);		//

	glVertex3f(310,50,-15);		//
	glVertex3f(300,50,-15);		// palette de droite et face tourne vers -z
	glVertex3f(300,-50,-15);	//
	glVertex3f(310,-50,-15);	//

	glVertex3f(300,50,15);		//
	glVertex3f(300,50,-15);		// palette de droite et face tourne vers x
	glVertex3f(300,-50,-15);	//
	glVertex3f(300,-50,15);		//

	glVertex3f(310,50,15);		//
	glVertex3f(310,50,-15);		// palette de droite et face tourne vers -x
	glVertex3f(310,-50,-15);	//
	glVertex3f(310,-50,15);		//

	glVertex3f(310,50,15);		//
	glVertex3f(300,50,15);		// palette de droite et face tourne vers +y
	glVertex3f(300,50,-15);		//
	glVertex3f(310,50,-15);		//

	glVertex3f(310,-50,15);		//
	glVertex3f(300,-50,15);		// palette de droite et face tourne vers -y
	glVertex3f(300,-50,-15);	//
	glVertex3f(310,-50,-15);	//

	glEnd();

	glColor3d(0,0,0);
	glBegin(GL_LINES);

	glVertex3f(299.9,50.1,15.1);glVertex3f(299.9,-50.1,15.1);		//
	glVertex3f(310.1,50.1,15.1);glVertex3f(310.1,-50.1,15.1);		//
	glVertex3f(299.9,50.1,-15.1);glVertex3f(299.9,-50.1,-15.1);		// coordonnes
	glVertex3f(310.1,50.1,-15.1);glVertex3f(310.1,-50.1,-15.1);		// des
	glVertex3f(310.1,50.1,15.1);glVertex3f(299.9,50.1,15.1);		// lignes
	glVertex3f(310.1,50.1,-15.1);glVertex3f(299.9,50.1,-15.1);		// noires
	glVertex3f(310.1,-50.1,15.1);glVertex3f(299.9,-50.1,15.1);		// composant
	glVertex3f(310.1,-50.1,-15.1);glVertex3f(299.9,-50.1,-15.1);	// la
	glVertex3f(310.1,50.1,15.1);glVertex3f(310.1,50.1,-15.1);		// palette
	glVertex3f(299.9,50.1,15.1);glVertex3f(299.9,50.1,-15.1);		// de droite
	glVertex3f(310.1,-50.1,15.1);glVertex3f(310.1,-50.1,-15.1);		//
	glVertex3f(299.9,-50.1,15.1);glVertex3f(299.9,-50.1,-15.1);		//

	glEnd();
}

/*****************************\FONCTION D'AFFICHAGE DES PALETTES******************************/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
/*********************************************************************************************/
/******                          FONCTION D'AFFICHAGE DU DECOR                          ******/
/******                          -----------------------------                          ******/
/******    Cette fonction sert uniquement  mettre le dcor en place...                 ******/
/******    Affichage des murs et des pointills...  En fait de tout ce qui est fixe.    ******/
/******    Au dbut il commence par afficher les faces blanches avec GL_QUADS           ******/
/******    Puis les lignes noires avec GL_LINES                                         ******/
/******    Et enfin les pointills avec deux boucles se chargeant de faire              ******/
/******    respectivement les faces blanches et les lignes noires                       ******/
/******                                                                                 ******/
/*********************************************************************************************/

void decor()
{
	glColor3d(1,1,1);
	glBegin(GL_QUADS);

	glVertex3f(-320,240,15);  //
	glVertex3f(320,240,15);   // mur du haut et face tourne vers +z
	glVertex3f(320,220,15);   //
	glVertex3f(-320,220,15);  //

	glVertex3f(-320,220,-15); //
	glVertex3f(320,220,-15);  // mur du haut et face tourne vers -z
	glVertex3f(320,240,-15);  //
	glVertex3f(-320,240,-15); //

	glVertex3f(-320,240,15);  //
	glVertex3f(-320,240,-15); // mur du haut et face tourne vers -x
	glVertex3f(-320,220,-15); //
	glVertex3f(-320,220,15);  //

	glVertex3f(320,240,15);   //
	glVertex3f(320,240,-15);  // mur du haut et face tourne vers +x
	glVertex3f(320,220,-15);  //
	glVertex3f(320,220,15);   //

	glVertex3f(-320,240,15);  //
	glVertex3f(320,240,15);   // mur du haut et face tourne vers +y
	glVertex3f(320,240,-15);  //
	glVertex3f(-320,240,-15); //

	glVertex3f(-320,220,15);  //
	glVertex3f(320,220,15);   // mur du haut et face tourne vers -y
	glVertex3f(320,220,-15);  //
	glVertex3f(-320,220,-15); //

	glVertex3f(-320,-240,15); //
	glVertex3f(320,-240,15);  // mur du bas et face tourne vers +z
	glVertex3f(320,-220,15);  //
	glVertex3f(-320,-220,15); //

	glVertex3f(-320,-240,-15);//
	glVertex3f(320,-240,-15); // mur du bas et face tourne vers -z
	glVertex3f(320,-220,-15); //
	glVertex3f(-320,-220,-15);//

	glVertex3f(-320,-240,15); //
	glVertex3f(-320,-240,-15);// mur du bas et face tourne vers -x
	glVertex3f(-320,-220,-15);//
	glVertex3f(-320,-220,15); //

	glVertex3f(320,-240,15);  //
	glVertex3f(320,-240,-15); // mur du bas et face tourne vers +x
	glVertex3f(320,-220,-15); //
	glVertex3f(320,-220,15);  //

	glVertex3f(-320,-220,15); //
	glVertex3f(320,-220,15);  // mur du bas et face tourne vers +y
	glVertex3f(320,-220,-15); //
	glVertex3f(-320,-220,-15);//

	glVertex3f(-320,-240,15); //
	glVertex3f(320,-240,15);  // mur du bas et face tourne vers -y
	glVertex3f(320,-240,-15); //
	glVertex3f(-320,-240,-15);//

	if(mode==2)
	{
		glVertex3f(300,220,15);   //
		glVertex3f(320,220,15);   // mur de droite et face tourne vers +z
		glVertex3f(320,-220,15);  //
		glVertex3f(300,-220,15);  //

		glVertex3f(300,220,-15);  //
		glVertex3f(320,220,-15);  // mur de droite et face tourne vers -z
		glVertex3f(320,-220,-15); //
		glVertex3f(300,-220,-15); //

		glVertex3f(320,220,15);   //
		glVertex3f(320,220,-15);  // mur de droite et face tourne vers +x
		glVertex3f(320,-220,-15); //
		glVertex3f(320,-220,15);  //

		glVertex3f(300,220,15);   //
		glVertex3f(300,220,-15);  // mur de droite et face tourne vers -x
		glVertex3f(300,-220,-15); //
		glVertex3f(300,-220,15);  //
	}

	glEnd();

	glColor3d(0,0,0);

	glBegin(GL_LINES);

	glVertex3f(-320.1,240.1,15.1);glVertex3f(320.1,240.1,15.1);     //
	glVertex3f(-320.1,219.9,15.1);glVertex3f(320.1,219.9,15.1);     //
	glVertex3f(-320.1,240.1,-15.1);glVertex3f(320.1,240.1,-15.1);   //
	glVertex3f(-320.1,219.9,-15.1);glVertex3f(320.1,219.9,-15.1);   //
	glVertex3f(-320.1,240.1,15.1);glVertex3f(-320.1,219.9,15.1);    //
	glVertex3f(-320.1,240.1,-15.1);glVertex3f(-320.1,219.9,-15.1);  // mur du haut
	glVertex3f(-320.1,240.1,-15.1);glVertex3f(-320.1,240.1,15.1);   //
	glVertex3f(-320.1,219.9,-15.1);glVertex3f(-320.1,219.9,15.1);   //
	glVertex3f(320.1,240.1,15.1);glVertex3f(320.1,219.9,15.1);      //
	glVertex3f(320.1,240.1,-15.1);glVertex3f(320.1,219.9,-15.1);    //
	glVertex3f(320.1,240.1,-15.1);glVertex3f(320.1,240.1,15.1);     //
	glVertex3f(320.1,219.9,-15.1);glVertex3f(320.1,219.9,15.1);     //

	glVertex3f(-320.1,-240.1,15.1);glVertex3f(320.1,-240.1,15.1);   //
	glVertex3f(-320.1,-219.9,15.1);glVertex3f(320.1,-219.9,15.1);   //
	glVertex3f(-320.1,-240.1,-15.1);glVertex3f(320.1,-240.1,-15.1); //
	glVertex3f(-320.1,-219.9,-15.1);glVertex3f(320.1,-219.9,-15.1); //
	glVertex3f(-320.1,-240.1,15.1);glVertex3f(-320.1,-219.9,15.1);  //
	glVertex3f(-320.1,-240.1,-15.1);glVertex3f(-320.1,-219.9,-15.1);// mur du bas
	glVertex3f(-320.1,-240.1,-15.1);glVertex3f(-320.1,-240.1,15.1); //
	glVertex3f(-320.1,-219.9,-15.1);glVertex3f(-320.1,-219.9,15.1); //
	glVertex3f(320.1,-240.1,15.1);glVertex3f(320.1,-219.9,15.1);    //
	glVertex3f(320.1,-240.1,-15.1);glVertex3f(320.1,-219.9,-15.1);  //
	glVertex3f(320.1,-240.1,-15.1);glVertex3f(320.1,-240.1,15.1);   //
	glVertex3f(320.1,-219.9,-15.1);glVertex3f(320.1,-219.9,15.1);   //

	if(mode==2)
	{
		glVertex3f(299.9,219.9,15.1);glVertex3f(299.9,-219.9,15.1);		//
		glVertex3f(299.9,219.9,-15.1);glVertex3f(299.9,-219.9,-15.1);	//
		glVertex3f(320.1,219.9,15.1);glVertex3f(320.1,-219.9,15.1);		// mur de droite
		glVertex3f(320.1,219.9,-15.1);glVertex3f(320.1,-219.9,-15.1);	//
		glVertex3f(299.9,219.9,15.1);glVertex3f(299.9,219.9,-15.1);		//
		glVertex3f(299.9,-219.9,15.1);glVertex3f(299.9,-219.9,-15.1);	//
	}

	glEnd();

	glColor3d(1,1,1);
	glBegin(GL_QUADS);

	for(i=2189;i>=-2140;i=i-283)
	{
		glVertex3f(3.5,i/10,-15);
		glVertex3f(3.5,(i-150)/10,-15);
		glVertex3f(-3.5,(i-150)/10,-15);
		glVertex3f(-3.5,i/10,-15);
	}

	glEnd();

	glColor3d(0,0,0);
	glBegin(GL_LINES);
	for(i=2189;i>=-2200;i=i-283)
	{
		glVertex3f(-3.51,i/10,-15);glVertex3f(-3.51,(i-150)/10,-15);
		glVertex3f(3.51,i/10,-15);glVertex3f(3.51,(i-150)/10,-15);
		glVertex3f(3.51,i/10,-15);glVertex3f(-3.51,i/10,-15);
		glVertex3f(-3.51,(i-150)/10,-15);glVertex3f(3.51,(i-150)/10,-15);
	}


	glEnd();
}

/********************************\FONCTION D'AFFICHAGE DU DECOR*******************************/
