#ifndef KEYBOARD_H
#define KEYBOARD_H

/*********************************************************************************************/
/******                        DECLARATIONS ET INITIALISATIONS                          ******/
/******                        -------------------------------                          ******/
/******    Touche : fonction prenant en charge la pression des touches "normales"       ******/
/******    ToucheUp : fonction prenant en charge le relchement des touches             ******/
/******    ToucheSpec : fonction prenant en charge la pression des touches "speciales"  ******/
/******    ToucheSpecUp : fonction prenant en charge le relchement des touches         ******/
/******                   "speciales"                                                   ******/
/******    Touche2 : fonction qui prend les caractres pour les afficher  l'cran      ******/
/******                                                                                 ******/
/******    Les variables externes sont expliques dans le fichier main.c                ******/
/******                                                                                 ******/
/*********************************************************************************************/

#include <GL/gl.h>
#include <GL/glut.h>
#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>
#include <SDL/SDL_mixer.h>
#include "savefile.h"
#include "divers.h"

void Touche(unsigned char key, int x, int y);
void ToucheUp(unsigned char key, int x, int y);
void ToucheSpec(int key, int x, int y);
void ToucheSpecUp(int key, int x, int y);
void Touche2(unsigned char key, int x, int y);
void Touche3(unsigned char key, int x, int y);
void Touche4(unsigned char key, int x, int y);
void Touche5(unsigned char key, int x, int y);

extern int up, down, up2, down2, arret, mouv, mode;
extern int options, menuquit, credits, menudifficulte, reseau;
extern int pasmusique;
extern Mix_Music * son_menu;
extern int width, height;
extern int barredespace;
extern int points, etat;
extern unsigned char * pseudo;
extern unsigned char * ip;
extern unsigned char * chatboxtext;
extern unsigned char * newgametext;

/******************************\DECLARATIONS ET INITIALISATIONS*******************************/


#endif
