#ifndef MOUSE_H
#define MOUSE_H

/*********************************************************************************************/
/******                        DECLARATIONS ET INITIALISATIONS                          ******/
/******                        -------------------------------                          ******/
/******    souris : fonction qui prend en charge la position de la souris               ******/
/******    sourisclic : fonction qui prend en charge le clic de la souris               ******/
/******                                                                                 ******/
/******    Les variables externes sont expliques dans le fichier main.c                ******/
/******                                                                                 ******/
/******    nbr_rand : Une variable simplement utilise pour stocker un nombre alatoire ******/
/******                                                                                 ******/
/*********************************************************************************************/

#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glut.h>
#include "savefile.h"
#include "keyboard.h"
#include "init.h"

void sourisclic(int bouton, int etat, int x, int y);
void sourisclic2(int bouton, int etat, int x, int y);
void souris(int x, int y);

extern int mode, choix, forme, son;
extern int mouv;
extern int arret;
extern float camx, camy, camz;
extern float vertx, verty, vertz;
extern int options, menuquit, credits, menudifficulte, reseau, menuip, menureseau;
extern int vsync, sourisactive, sensibilitesouris, fer, accballe, inertie, reso_1024, pasmusique, pasbruitage, barredespace;
extern Mix_Music * son_jeu;
extern Mix_Music * son_menu;
extern int choixia;
extern int fps;
extern double ballex, balley, ballez;
extern double ballevx, ballevy, ballevz;
extern float rotballe;
extern int up2, down2;
extern int points;
extern int ajoutpoint;
extern char score01[10];
extern int j;
extern int width, height;
extern int sourisx, sourisy;
extern float palettegy, palettedy;
extern double palettegvy, palettedvy;
extern int reso, win, infos;

float sourismouvx, sourismouvy;

/******************************\DECLARATIONS ET INITIALISATIONS*******************************/


#endif
