#include "mouvpal.h"

/*********************************************************************************************/
/******               FONCTION DE DEPLACEMENT DES PALETTES AVEC INERTIE                 ******/
/******               -------------------------------------------------                 ******/
/******    Cette fonction est loin d'tre complique.  Il s'agit juste de quelques      ******/
/******    conditions pour ne pas que la palette puisse traverser les murs et qu'elle   ******/
/******    possde une toute petite intertie ce qui amliore le gameplay et le fun du   ******/
/******    jeu.  En trs gros, la vitesse de la palette augmente et diminue             ******/
/******    progressivement et non par  coups...  De mme, si on change la direction    ******/
/******    de la palette, il faudra d'abord contrer la vitesse active dans la direction ******/
/******    premire avant qu'elle ne se dirige dans la direction voulue.                ******/
/******                                                                                 ******/
/*********************************************************************************************/

void deplacementpaletteg()
{
	if(sourismouvx != 0. && up == 0 && down == 0)
	{
		palettegvy=sourismouvx;
	}
	else
	{
		if(up==1 && palettegy+palettegvy+50<220)
		{
			if(down==0)
			{
				if(palettegvy<(float)10/refresh*85)
					palettegvy=palettegvy+(float)1/refresh*85;
			}
		}
		if(down==1 && palettegy+palettegvy-50>-220)
		{
			if(up==0)
			{
				if(palettegvy>-(float)10/refresh*85)
					palettegvy=palettegvy-(float)1/refresh*85;
			}
		}
	}
	
	if(palettegy+palettegvy+50>=220)
	{
		palettegvy=0;
		palettegy=219.5-50;
	}
	if(palettegy+palettegvy-50<=-220)
	{
		palettegvy=0;
		palettegy=-219.5+50;
	}
	if(sourismouvx == 0 && up==down)
	{
		palettegvy=palettegvy-(palettegvy/(float)5/refresh*85);
	}

	glTranslatef(0.0,palettegy,0.0);
}

void deplacementpaletted()
{
	if(up2==1 && palettedy+palettedvy+50<220)
	{
		if(down2==0)
		{
			if(palettedvy<(float)10/refresh*85)palettedvy=palettedvy+(float)1/refresh*85;
		}
	}
	if(down2==1 && palettedy+palettedvy-50>-220)
	{
		if(up2==0)
		{
			if(palettedvy>-(float)10/refresh*85)palettedvy=palettedvy-(float)1/refresh*85;
		}
	}
	if(palettedy+palettedvy+50>=220)
	{
		palettedvy=0;
		palettedy=219.5-50;
	}
	if(palettedy+palettedvy-50<=-220)
	{
		palettedvy=0;
		palettedy=-219.5+50;
	}
	if(up2==down2)
	{
		palettedvy=palettedvy-(palettedvy/(float)5/refresh*85);
	}
	glTranslatef(0.0,palettedy,0.0);
}

/*********************\FONCTION DE DEPLACEMENT DES PALETTES AVEC INERTIE**********************/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
                                            /**/
/*********************************************************************************************/
/******               FONCTION DE DEPLACEMENT DES PALETTES SANS INERTIE                 ******/
/******               -------------------------------------------------                 ******/
/******    Cette fonction est encore plus simple que la prcdente, elle sert uniquement******/
/******     donner une alternative aux joueurs qui n'aiment pas l'inertie.             ******/
/******    Son principe est la mme que pour la fonction prcdente.                    ******/
/******                                                                                 ******/
/*********************************************************************************************/

void deplacementpaletteg2()
{
	if(up==1 && down==0 && palettegy+palettegvy+50<220)
	{
		palettegvy=8.5;
	}
	if(up==0 && down==1 && palettegy+palettegvy+50>-220)
	{
		palettegvy=-8.5;
	}
	if(up==down)
	{
		if(sourismouvx != 0.)
			palettegvy=sourismouvx;
		else
			palettegvy=0;
	}
	if(palettegy+palettegvy+50>=220)
	{
		palettegvy=0;
		palettegy=219.5-50;
	}
	if(palettegy+palettegvy-50<=-220)
	{
		palettegvy=0;
		palettegy=-219.5+50;
	}
	glTranslatef(0.0,palettegy,0.0);
}

void deplacementpaletted2()
{
	if(up2==1 && down2==0 && palettedy+palettedvy+50<220)
	{
		palettedvy=8.5;
	}
	if(up2==0 && down2==1 && palettedy+palettedvy+50>-220)
	{
		palettedvy=-8.5;
	}
	if(up2==down2)
	{
		palettedvy=0;
	}
	if(palettedy+palettedvy+50>=220)
	{
		palettedvy=0;
		palettedy=219.5-50;
	}
	if(palettedy+palettedvy-50<=-220)
	{
		palettedvy=0;
		palettedy=-219.5+50;
	}
	glTranslatef(0.0,palettedy,0.0);
}

/*********************\FONCTION DE DEPLACEMENT DES PALETTES SANS INERTIE**********************/
